<script setup>
import Wrapper from './_Wrapper.vue';
</script>

<script>
export default {
    data() {
        return {
            id: 'input-' + this.booted.helpers.string.uniqueId(),
            options: this.$attrs.options,
            items: [],
            fileInputOptions: {
                initialPreviewAsData: true,
                overwriteInitial: false,
                showCaption: false,
                showUpload: false,
                showRemove: false,
                showDelete: false,
                showCancel: false,
                showClose: false,
                browseOnZoneClick: true,

                browseClass: 'btn btn-primary btn-block',
                browseIcon: '<i class="fas fa-folder-open"></i>',
                removeClass: 'btn btn-danger btn-block float-right mt-1 mb-2',
                removeIcon: '<i class="fas fa-trash-alt"></i>',

                fileActionSettings: {
                    showDrag: false,
                    dragClass: 'text-primary',
                    dragIcon: '<i class="fas fa-arrows-alt"></i>',
                    zoomClass: 'btn btn-info',
                    zoomIcon: '<i class="fas fa-search-plus"></i>',
                    downloadClass: 'btn btn-primary pull-left',
                    downloadIcon: '<i class="fas fa-cloud-download-alt"></i>',
                    removeClass: 'btn btn-danger',
                    removeIcon: '<i class="fas fa-trash-alt"></i>',
                },
                previewZoomButtonIcons: {
                    prev: '<i class="fas fa-caret-left"></i>',
                    next: '<i class="fas fa-caret-right"></i>',
                    toggleheader: '<i class="far fa-window-maximize"></i>',
                    fullscreen: '<i class="fas fa-compress"></i>',
                    borderless: '<i class="fas fa-arrows-alt"></i>',
                    close: '<i class="fas fa-times"></i>',
                },

                initialPreviewFileType: 'image',
                ajaxDeleteSettings: {
                    type: 'DELETE',
                    headers: this.booted.config.http.headers,
                },
            },
        };
    },
    mounted() {
        this.collectItems();

        let layoutTemplates = {
            actions: '{drag}<div class="file-actions"><div class="file-footer-buttons">{zoom} {download} {delete}</div></div>',
        };

        if (!this.options.deletePath) {
            layoutTemplates.actions = layoutTemplates.actions.replace('{delete}', '');
        }

        this.fileInputOptions.layoutTemplates = layoutTemplates;
        this.fileInputOptions.initialPreview = this.items.map((value, key) => value.previewUrl);
        this.fileInputOptions.initialPreviewConfig = this.items;

        $('#' + this.id).fileinput(this.fileInputOptions);

        $('#' + this.id).on('filedeleted', (event, key) => {
            this.$attrs.value.splice(key, 1);
            this.collectItems();

            this.fileInputOptions.initialPreview = this.items.map((value, key) => value.previewUrl);
            this.fileInputOptions.initialPreviewConfig = this.items;

            $('#' + this.id).fileinput('destroy').fileinput(this.fileInputOptions);
        });
    },
    methods: {
        collectItems() {
            let items = [],
                value = this.$attrs.value;

            if (!this.options.isMultiple) {
                value = [value];
            }

            for (let key in value) {
                let file = value[key],
                    url = this.options.deletePath;

                if (url) {
                    url = url.replace(':id', this.$route.params.id).replace(':index', key);
                }

                items[key] = {
                    previewUrl: this.options.previewPath ? file[this.options.previewPath] : file,
                    downloadUrl: this.options.downloadPath ? file[this.options.downloadPath] : file,
                    url: this.booted.config.http.url.main + '/' + url,
                    caption: 'File ' + (parseInt(key) + 1),
                    key: key,
                    type: 'image',
                };
            }

            this.items = items;
        },
    },
};
</script>

<template>
    <Wrapper :id="id" v-slot="main">
        <input type="file" v-bind="main.inputAttrs" :multiple="options.isMultiple" value="">
    </Wrapper>
</template>